#include <sys/types.h>

enum op_align
{OPERAND_INVALID, OPERAND_ALIGNED, OPERAND_UNALIGNED};

extern uint64_t		    zero64[], zero128[], beef64[], beef128[];

typedef struct {
    int			    length;
    uint8_t		   *start;
    uint8_t		   *aligned;
    char		   *str;
} operand;

operand *alloc_struct(int length, int align, enum op_align offset);
operand *alloc_operand64(int align, enum op_align offset);
operand *alloc_operand128(int align, enum op_align offset);
operand *hex2operand64(char *str, int align, enum op_align offset);
operand *hex2operand128(char *str, int align, enum op_align offset);
char *operand2str(operand *p);
void free_operand(operand *p);

